-- Note to self: environment variables: set

-- These functions assume you're not on a school computer or anywhere where cmd is completely restricted.

-- (http://stackoverflow.com/questions/5303174/get-list-of-directory-in-a-lua)
function listfiles(directory)
	local i, t, popen = 0, {}, io.popen
	--for filename in popen('ls -a "'..directory..'"'):lines() do
	
	-- Only do files.
	for filename in popen('dir "'..directory..'" /b /a-d'):lines() do
		i = i + 1
		t[i] = filename
		
		--cons(filename)
	end
	return t
end

function getlevelsfolder()
	-- Returns error, path
	-- 1: no documents, 2: no vvvvvv, 3: no levels folder

	-- We know we're on Windows for a start...
	userprofile = os.getenv('USERPROFILE')
	-- documents = getdocuments(userprofile)
	
	--[[
	if directory_exists(userprofile, "Documents") then
		documents = "Documents"
	elseif directory_exists(userprofile, "My Documents") then
		documents = "My Documents"
	else
		return 1, nil
	end
	
	if not directory_exists(userprofile .. "\\" .. documents, "VVVVVV") then
		return 2, nil
	end
	
	if not directory_exists(userprofile .. "\\" .. documents .. "\\VVVVVV", "levels") then
		return 3, nil
	else
		return 0, userprofile .. "\\" .. documents .. "\\VVVVVV\\levels"
	end
	]]
	
	-- Spawn less cmd windows
	if directory_exists(userprofile .. "\\Documents\\VVVVVV", "levels") then
		return 0, userprofile .. "\\Documents\\VVVVVV\\levels"
	elseif directory_exists(userprofile .. "\\My Documents\\VVVVVV", "levels") then
		return 0, userprofile .. "\\My Documents\\VVVVVV\\levels"
	else
		-- Also return what it should have been
		return 4, userprofile .. "\\(My) Documents\\VVVVVV\\levels"
	end
end

function listdirs(directory)
	local i, t, popen = 0, {}, io.popen
	--for filename in popen('ls -a "'..directory..'"'):lines() do
	
	-- Only do folders.
	for filename in popen('dir "'..directory..'" /b /ad'):lines() do
		i = i + 1
		t[i] = filename
		
		--cons(filename)
	end
	return t
end

function directory_exists(where, what)
	local i, t, popen = 0, {}, io.popen
	
	for filename in popen('dir "'..where..'" /b /ad'):lines() do
		if filename == what then return true end
	end
	
	-- If we're here, then the dir doesn't exist.
	return false
end

function readlevelfile(path)
	-- returns success, contents

	fh, everr = io.open(path, "r")
	
	if fh == nil then
		return false, everr
	end
	
	local ficontents = fh:read("*a")
	
	fh:close()
	
	return true, ficontents
end

function writelevelfile(path, contents)
	-- returns success, (if not) error message

	fh, everr = io.open(path, "w")
	
	if fh == nil then
		return false, everr
	end
	
	local ficontents = fh:write(contents)
	
	fh:close()
	
	return true, nil
end

--[[
function getdocuments(directory)
	local i, t, popen = 0, {}, io.popen
	local docs, mydocs

	-- Only do folders.
	for filename in popen('dir "'..directory..'" /b /ad'):lines() do
		if filename == "Documents" then docs = true end
		if filename == "My Documents" then mydocs = true end
	end
	
	if docs then
		return "Documents"
	elseif mydocs then
		return "My Documents"
	else
		return nil
	end
end

function directory_exists(directory)
	local i, t, popen = 0, {}, io.popen

	return popen('cd "' .. directory .. '"')
end
]]