-- Ok the array (roomdata) with tiles is just continuous for a single room (so it has 1200 items) FOR each array item, roomdata[y][x] contains all the tiles
-- The array entitydata is an array containing entities as subarrays
-- And then there's a roommeta array that contains all the metadata of a room (like roomname and such)

-- This is per room so multiple arrays can be set if zoomed out.

--[[ Also, somewhere, there should be an array with tilesets and all their colors but what tiles they actually use in what tileset
Something like:

tilesets =
	{
	'ship' =
		{
		'tilesetid' = 46,
		'tileimg' = 'tiles2',
		'colors' =
			{
			'red' =
				{
				'colorid' = 15,
				'blocks' =
					{
					1, 2, 3, 11, 12, 13, 21, 22, 23
					},
				'background' =
					{
					31, 32, 33, 41, 42, 43, 51, 52, 53
					}
				}
			}
		}
	}
]]


function loademptyroom()
	-- Generate an entirely empty room with no entities nor metadata.
	cons("Generating empty room")
	
	myroomdata = {}
	
	for k = 1, 1200 do
		myroomdata[k] = 0 -- Just to test.
	end
	
	myentitydata = {}
	
	mymetadata = {}
	
	mymetadata.roomname = "Untitled room"
	mymetadata.tileset = 1
	
	return myroomdata, myentitydata, mymetadata
end

function loadrohiom(x, y)
	-- Loads blocks of a room from level data and prepares it for display. Also loads entities and metadata.
	
	return myroomdata, myentitydata, mymetadata
end

function displayroom(offsetx, offsety, theroomdata, themetadata)
	-- This assumes the room is already loaded in roomdata. It just displays a room, without the entities. Also include scale for zooming out.
	for aty = 0, 29 do
		for atx = 0, 39 do
			-- Display roomdata[(aty*40)+(atx+1)]
			--cons("Will display: (aty*40)+(atx+1) in other words " .. (aty*40)+(atx+1) .. " (at " .. atx .. " " .. aty .. ")")
			love.graphics.draw(tilesets[tilesetnames[usedtilesets[themetadata.tileset]]]["img"], tilesets[tilesetnames[usedtilesets[themetadata.tileset]]]["tiles"][tonumber(theroomdata[(aty*40)+(atx+1)])], offsetx+(16*atx*zoomscale), offsety+(16*aty*zoomscale), 0, zoomscale)
		end
	end
end

function displayentities(offsetx, offsety, myroomx, myroomy)
	-- This assumes the entities for this room are already loaded in entitydata. It just displays all entities.
	if allowdebug then
		showtooltip = true
	else
		showtooltip = false
	end
	
	showtooltipof = nil
	
	for k,v in pairs(entitydata) do
		if (v.x >= myroomx*40) and (v.x <= (myroomx*40)+39) and (v.y >= myroomy*30) and (v.y <= (myroomy*30)+29) then
			-- What kind of entity is this?
			if allowdebug and love.keyboard.isDown("/") then
				love.graphics.draw(cursorimg[5], offsetx+(v.x-myroomx*40)*16, offsety+(v.y-myroomy*30)*16)
			elseif v.t == 1 then
				-- Enemy NEEDS MORE RESEARCH FOR ENEMY TYPES AND SUCH
				drawentity(78, offsetx+(v.x-myroomx*40)*16, offsety+(v.y-myroomy*30)*16)
				entityrightclick(offsetx+(v.x-myroomx*40)*16, offsety+(v.y-myroomy*30)*16, {"#" .. toolnames[9], L.DELETE, L.DIRECTION .. L.UP, L.DIRECTION .. L.DOWN, L.DIRECTION .. L.LEFT, L.DIRECTION .. L.RIGHT, L.PROPERTIES}, "ent_1_" .. k)
			elseif v.t == 2 then
				-- Platform, it's either a moving one or a conveyor!
				love.graphics.draw(tilesets["tiles2.png"]["img"], tilesets["tiles2.png"]["tiles"][301], offsetx+(v.x-myroomx*40)*16, offsety+(v.y-myroomy*30)*16)
				love.graphics.draw(tilesets["tiles2.png"]["img"], tilesets["tiles2.png"]["tiles"][302], offsetx+(v.x-myroomx*40)*16 + 16, offsety+(v.y-myroomy*30)*16)
				love.graphics.draw(tilesets["tiles2.png"]["img"], tilesets["tiles2.png"]["tiles"][302], offsetx+(v.x-myroomx*40)*16 + 32, offsety+(v.y-myroomy*30)*16)
				if v.p1 < 7 then
					-- 4 tiles
					love.graphics.draw(tilesets["tiles2.png"]["img"], tilesets["tiles2.png"]["tiles"][303], offsetx+(v.x-myroomx*40)*16 + 48, offsety+(v.y-myroomy*30)*16)
				else
					-- 8 tiles
					love.graphics.draw(tilesets["tiles2.png"]["img"], tilesets["tiles2.png"]["tiles"][302], offsetx+(v.x-myroomx*40)*16 + 48, offsety+(v.y-myroomy*30)*16)
					love.graphics.draw(tilesets["tiles2.png"]["img"], tilesets["tiles2.png"]["tiles"][302], offsetx+(v.x-myroomx*40)*16 + 64, offsety+(v.y-myroomy*30)*16)
					love.graphics.draw(tilesets["tiles2.png"]["img"], tilesets["tiles2.png"]["tiles"][302], offsetx+(v.x-myroomx*40)*16 + 80, offsety+(v.y-myroomy*30)*16)
					love.graphics.draw(tilesets["tiles2.png"]["img"], tilesets["tiles2.png"]["tiles"][302], offsetx+(v.x-myroomx*40)*16 + 96, offsety+(v.y-myroomy*30)*16)
					love.graphics.draw(tilesets["tiles2.png"]["img"], tilesets["tiles2.png"]["tiles"][303], offsetx+(v.x-myroomx*40)*16 + 112, offsety+(v.y-myroomy*30)*16)
				end
				entityrightclick(offsetx+(v.x-myroomx*40)*16, offsety+(v.y-myroomy*30)*16, {"#" .. toolnames[7] .. "/" .. toolnames[8], L.DELETE, L.PROPERTIES}, "ent_2_" .. k)
			elseif v.t == 3 then
				-- Disappearing platform
				love.graphics.draw(tilesets["tiles2.png"]["img"], tilesets["tiles2.png"]["tiles"][301], offsetx+(v.x-myroomx*40)*16, offsety+(v.y-myroomy*30)*16)
				love.graphics.draw(tilesets["tiles2.png"]["img"], tilesets["tiles2.png"]["tiles"][302], offsetx+(v.x-myroomx*40)*16 + 16, offsety+(v.y-myroomy*30)*16)
				love.graphics.draw(tilesets["tiles2.png"]["img"], tilesets["tiles2.png"]["tiles"][302], offsetx+(v.x-myroomx*40)*16 + 32, offsety+(v.y-myroomy*30)*16)
				love.graphics.draw(tilesets["tiles2.png"]["img"], tilesets["tiles2.png"]["tiles"][303], offsetx+(v.x-myroomx*40)*16 + 48, offsety+(v.y-myroomy*30)*16)
				entityrightclick(offsetx+(v.x-myroomx*40)*16, offsety+(v.y-myroomy*30)*16, {"#" .. toolnames[6], L.DELETE, L.PROPERTIES}, "ent_3_" .. k)
			elseif v.t == 9 then
				-- Trinket
				drawentity(22, offsetx+(v.x-myroomx*40)*16, offsety+(v.y-myroomy*30)*16)
				entityrightclick(offsetx+(v.x-myroomx*40)*16, offsety+(v.y-myroomy*30)*16, {"#" .. toolnames[4], L.DELETE, L.PROPERTIES}, "ent_9_" .. k)
			elseif v.t == 10 then
				-- Checkpoint
				if v.p1 == 1 then
					-- Upright
					drawentity(21, offsetx+(v.x-myroomx*40)*16, offsety+(v.y-myroomy*30)*16)
				else
					-- Upside down
					drawentity(20, offsetx+(v.x-myroomx*40)*16, offsety+(v.y-myroomy*30)*16)
				end
				entityrightclick(offsetx+(v.x-myroomx*40)*16, offsety+(v.y-myroomy*30)*16, {"#" .. toolnames[5], L.DELETE, L.TESTFROMHERE, L.PROPERTIES}, "ent_10_" .. k)
			elseif v.t == 11 then
				-- Gravity line. This is kind of a special story.
				if v.p1 == 0 then
					-- Horizontal
					love.graphics.line(offsetx+(v.p2)*16 + 1, offsety+(v.y-myroomy*30)*16 + 8, offsetx+(v.p2)*16 + v.p3*2 - 1, offsety+(v.y-myroomy*30)*16 + 8)
				else
					-- Vertical
					love.graphics.line(offsetx+(v.x-myroomx*40)*16 + 8, offsety+(v.p2)*16 + 1, offsetx+(v.x-myroomx*40)*16 + 8, offsety+(v.p2)*16 + v.p3*2 - 1)
				end
				
				-- Where is it, though?
				love.graphics.draw(cursorimg[0], offsetx+(v.x-myroomx*40)*16, offsety+(v.y-myroomy*30)*16)
				entityrightclick(offsetx+(v.x-myroomx*40)*16, offsety+(v.y-myroomy*30)*16, {"#" .. toolnames[10], L.DELETE, (v.p1 == 0 and L.CHANGETOVER or L.CHANGETOHOR), L.PROPERTIES}, "ent_11_" .. k)
			elseif v.t == 13 then
				-- Warp token
				drawentity(18, offsetx+(v.x-myroomx*40)*16, offsety+(v.y-myroomy*30)*16)
				entityrightclick(offsetx+(v.x-myroomx*40)*16, offsety+(v.y-myroomy*30)*16, {"#" .. toolnames[14], L.DELETE, L.GOTODESTINATION, L.PROPERTIES}, "ent_13_" .. k)
			elseif v.t == 15 then
				-- Rescuable crewmate
				drawentity(144, offsetx+(v.x-myroomx*40)*16 - 8, offsety+(v.y-myroomy*30)*16 + 2)
				entityrightclick(offsetx+(v.x-myroomx*40)*16, offsety+(v.y-myroomy*30)*16, {"#" .. toolnames[16], L.DELETE, L.CHANGECOLOR, L.PROPERTIES}, "ent_15_" .. k)
			elseif v.t == 16 then
				-- Start point
				drawentity(0, offsetx+(v.x-myroomx*40)*16 - 8, offsety+(v.y-myroomy*30)*16 + 2)
				entityrightclick(offsetx+(v.x-myroomx*40)*16, offsety+(v.y-myroomy*30)*16, {"#" .. toolnames[17], L.DELETE, L.TESTFROMHERE, L.PROPERTIES}, "ent_16_" .. k)
			elseif v.t == 17 then
				-- Roomtext
				love.graphics.setFont(font16)
				love.graphics.print(v.data, offsetx+(v.x-myroomx*40)*16, offsety+(v.y-myroomy*30)*16 + 3)
				love.graphics.setFont(font8)
				entityrightclick(offsetx+(v.x-myroomx*40)*16, offsety+(v.y-myroomy*30)*16, {"#" .. toolnames[11], L.DELETE, L.EDITTEXT, L.COPYTEXT, L.PROPERTIES}, "ent_17_" .. k)
			elseif v.t == 18 then
				-- Terminal
				drawentity(17, offsetx+(v.x-myroomx*40)*16, offsety+(v.y-myroomy*30)*16 + 16)
				entityrightclick(offsetx+(v.x-myroomx*40)*16, offsety+(v.y-myroomy*30)*16, {"#" .. toolnames[12], L.DELETE, L.EDITSCRIPT, L.OTHERSCRIPT, L.PROPERTIES}, "ent_18_" .. k)
			elseif v.t == 19 then
				-- Script box, draw it as an actual box.
				love.graphics.draw(cursorimg[1], offsetx+(v.x-myroomx*40)*16, offsety+(v.y-myroomy*30)*16)
				love.graphics.draw(cursorimg[2], offsetx+(v.x-myroomx*40)*16 + (v.p1-1)*16, offsety+(v.y-myroomy*30)*16)
				love.graphics.draw(cursorimg[3], offsetx+(v.x-myroomx*40)*16, offsety+(v.y-myroomy*30)*16 + (v.p2-1)*16)
				love.graphics.draw(cursorimg[4], offsetx+(v.x-myroomx*40)*16 + (v.p1-1)*16, offsety+(v.y-myroomy*30)*16 + (v.p2-1)*16)
				entityrightclick(offsetx+(v.x-myroomx*40)*16, offsety+(v.y-myroomy*30)*16, {"#" .. toolnames[13], L.DELETE, L.EDITSCRIPT, L.OTHERSCRIPT, L.RESIZE, L.PROPERTIES}, "ent_19_" .. k)
			else
				-- We don't know what this is, actually!
				love.graphics.draw(cursorimg[5], offsetx+(v.x-myroomx*40)*16, offsety+(v.y-myroomy*30)*16)
				showtooltip = true
				entityrightclick(offsetx+(v.x-myroomx*40)*16, offsety+(v.y-myroomy*30)*16, {"#" .. "Type " .. v.t, L.DELETE, L.PROPERTIES}, "ent_" .. v.t .. "_" .. k)
			end
			if showtooltip and mouseon(offsetx+(v.x-myroomx*40)*16, offsety+(v.y-myroomy*30)*16, 16, 16) then
				showtooltipof = v
			end
		end
	end
	
	-- Here so that other entities won't cover the tooltip
	if showtooltipof ~= nil then
		love.graphics.print("x=" .. showtooltipof.x .. "\ny=" .. showtooltipof.y .. "\nt=" .. showtooltipof.t .. "\np1=" .. showtooltipof.p1 .. "\np2=" .. showtooltipof.p2 .. "\np3=" .. showtooltipof.p3 .. "\np4=" .. showtooltipof.p4 .. "\np5=" .. showtooltipof.p5 .. "\np6=" .. showtooltipof.p6 .. "\ndata=" .. showtooltipof.data, love.mouse.getX()+24, love.mouse.getY()+24)
	end
end

function drawentity(tile, atx, aty)
	love.graphics.draw(tilesets["sprites.png"]["img"], tilesets["sprites.png"]["tiles"][tile], atx, aty, 0, 2)
end

function entityrightclick(x, y, menuitems, newmenuid)
	if love.mouse.isDown("r") and mouseon(x, y, 16, 16) then
		rightclickmenu.create(menuitems, newmenuid)
	end
end

function displaytilespicker(offsetx, offsety, tilesetname)
	love.graphics.draw(tilesets[tilesetname]["img"], offsetx, offsety)
end

function displaysmalltilespicker(offsetx, offsety, chosentileset, chosencolor)
	for ly = 0, 4 do
		for lx = 0, 5 do
			-- The number is (6ly)+lx+1. The below line is a monster.
			if selectedtool == 1 then -- wall
				love.graphics.draw(tilesets[tilesetnames[tilesetblocks[chosentileset].tileimg]]["img"], tilesets[tilesetnames[tilesetblocks[chosentileset].tileimg]]["tiles"][tilesetblocks[chosentileset].colors[chosencolor].blocks[(6*ly)+lx+1]], offsetx+(16*lx), offsety+(16*ly))
			elseif selectedtool == 2 then -- background
				love.graphics.draw(tilesets[tilesetnames[tilesetblocks[chosentileset].tileimg]]["img"], tilesets[tilesetnames[tilesetblocks[chosentileset].tileimg]]["tiles"][tilesetblocks[chosentileset].colors[chosencolor].background[(6*ly)+lx+1]], offsetx+(16*lx), offsety+(16*ly))
			elseif selectedtool == 3 then -- spikes
				love.graphics.draw(tilesets[tilesetnames[tilesetblocks[chosentileset].tileimg]]["img"], tilesets[tilesetnames[tilesetblocks[chosentileset].tileimg]]["tiles"][tilesetblocks[chosentileset].colors[chosencolor].spikes[(6*ly)+lx+1]], offsetx+(16*lx), offsety+(16*ly))
			end

			-- Are we hovering on this tile?
			if mouseon(offsetx+(16*lx), offsety+(16*ly), 16, 16) then
				love.graphics.draw(cursorimg[0], offsetx+(16*lx), offsety+(16*ly))
				
				-- Heck, maybe we're even clicking this.
				if love.mouse.isDown("l") then
					if selectedtool == 1 then -- wall
						youhavechosen = tilesetblocks[chosentileset].colors[chosencolor].blocks[(6*ly)+lx+1]
					elseif selectedtool == 2 then -- background
						youhavechosen = tilesetblocks[chosentileset].colors[chosencolor].background[(6*ly)+lx+1]
					elseif selectedtool == 3 then -- spikes
						youhavechosen = tilesetblocks[chosentileset].colors[chosencolor].spikes[(6*ly)+lx+1]
					end
					
					cons("Tile selected: " .. youhavechosen)
				
					selectedtile = youhavechosen
				end
			end
		end
	end
end

function bumpscript(script)
	-- Puts a script at the end of the array, making it appear at the top.
	local temp = scripts[script]
	table.remove(scripts, script)
	scripts[script] = temp
end